var g_URL;
var g_disciplineID;
var g_facultyID;
var $ = jQuery;
$(function() {
    g_URL = (window.location.href).split("/");
    g_disciplineID = g_URL[g_URL.length - 1];

    DisciplineID = g_disciplineID;
    
    var subjectsGlobal = [];
    
    // Получить список в память
    function GetSubjectsList()
    {
        var g_facultyID = 0;
        var optionVal = parseInt($("select.SelectFaculty").children("option:selected").val());
        if (optionVal <= 0)
            return;
        
        var g_facultyID = optionVal; 
        $.post(
            g_URLdir + "handler/map/GetSubjectsList",
            {
                "FacultyID": g_facultyID
            },
            function(data)
            {
                subjectsGlobal = (data != "") ? $.parseJSON(data) : {};
            }
        );
    }
    GetSubjectsList();
    
    // Сортировка списка
    function SortByName(nameFilter)
    {
        var nameFilter = nameFilter.toLowerCase();
        var sortSubjects = {};
        var j = 0;
        for (var i in subjectsGlobal) { 
            src = subjectsGlobal[i];
            if ((src.Title).toLowerCase().indexOf(nameFilter) == 0)
            {
                // 0 - успех, -1 - ничего не нашел 
                var dest = sortSubjects[j] = {};
                dest["ID"] = src.ID;
                dest["Title"] = src.Title;
                j++;
            }
        }
        sortSubjects.count = j;
        
        return sortSubjects;
    }

    // Для поиска предметов
    $(".InputSubject").keyup(function()
    {
        var nameFilter = $(this).val();

        if (nameFilter.length <= 0) {
            $(".SelectSubject").html("");
            return;
        }

        var sortSubjects = SortByName(nameFilter);
        var selectSubject = $(".SelectSubject");
        selectSubject.html("");
        if (sortSubjects.count > 0) {
			var jProto = $($.parseHTML("<option disabled>Выберите предмет ниже:</option>"));
			selectSubject.append(jProto.clone());
			jProto.removeAttr("disabled");
            for (var i = 0; i < sortSubjects.count; ++i) {
				jProto.html(sortSubjects[i].Title).val(sortSubjects[i].ID);
				selectSubject.append(jProto.clone());	
			}
			selectSubject.attr("size", 4);
        }
        else
            selectSubject.append("<option disabled>По запросу ничего не найдено.</option>").attr("size", "2");
        selectSubject.css('display', 'block');

    });
    


    $(".SelectFaculty").change(function(){
        GetSubjectsList($(this).val());
    });
    


    $(".SelectSubject").change(function(){
        $(".InputSubject").val($(this).children("option:selected").first().text());
        $(this).hide();
    });



    $(".InputSubject").focusout(function(){
        var selectSubject = $(".SelectSubject");
        var nameFilter = $(this).val();
        if (nameFilter.length == 0) {
            selectSubject.html("");
            selectSubject.hide();
        }
    });
    

    var jTemp = $(".HiddenInputFacultyID");
    if (jTemp.length > 0) {
        g_facultyID = jTemp.val(); // Факультет, к которой привязана дисциплина
        //jTemp.remove(); // Тут даже Шерлок Холмс бессилен
    }

})